! Point of information
+ New feature
- Bug fix

Version 2.29
------------
October 21, 2001

+ dupe detection on gated messages can now be set at the gate itself instead
  of relying on the mail tosser
! UUCP processing in Rex's SMTP daemon can now handle infinite (limited by
  available memory) email address on one C rmail line
! Rex now lingers on the sockets for certain servers to allow clients
  which incorrectly blast data through to still work properly
- Rex wasn't properly constructing nodelist information for BinkP nodes
  which listed the site address after the flag instead of in the BBS name
- resend requests would result in queue entries which never got removed
  when they expired
- outbound FTP client connections now bind to port 20 locally in PASV mode
- Rex could crash if it couldn't create a new packet for inbound gated mail
- a SEAT message with only 2 of 3 required SEAT lines would crash Rex
- updated packing info was not being saved in 32 bit versions
- Rex now correctly processes multi-section UUencoded files with additional
  information between the section line and beginning of the file
- seems to fix an unreproducible problem where PX queue entries remained
  locked after unsuccessful connection attempts
- long subject lines in gated netmail messages could result in random message
  chunk sizes for attached files

Version 2.28
------------
May 5, 2001

+ added hosting delivery system for the SMTP server in UUCP mode
+ Rex for Windows can now be iconified to the system tray using the -tray
  commandline argument
! auto-configuration of Fidonet BinkP nodes now tries fidonet.net addresses
  if no machine name is provided
! changed -s b to default to sending to anonymous nodes
- config fixups
- fix SRIF file formatting for nodes with multiple configured addresses
- correctly terminate truncated messages in the POP3 daemon
- correct a problem with substring base64 decodings which could result in
  problems with SMTP AUTH logins
- if more than one "must run" event was queued up at Rex's startup, a race
  condition could occur where the first event never got run
- Rex for DOS wasn't noticing refused connections on asynchronous sockets
- workaround for a threading issue with WinServer which could result in Rex
  freezing after a send event where no files were sent (PX/Wins systems only)
- changed mailbox storage so that changing SMTP server UUCP storage format
  doesn't result in messages delivered with the old format being "lost"
- wdialup.rex wasn't being properly loaded if Rex was run from somewhere
  other than its install directory
- the POP3 server wasn't properly retrieving messages stored in a UUCP
  spool with a UUCICO format
- Rex wasn't processing inbound FREQs over BinkP 1.1 connections with 
  multi-batch mode disabled
- FTP server security by IP was a bit overzealous
- manual sends to unlisted nodes weren't working
- correct a crash when viewing the queue with a session concurrent and at 
  least one non-sent queue entry

Version 2.27
------------
February 21, 2001

! some (possibly huge) increase in the speed of FTP server transfers: the
  hard disk or network card are now the limiting factor
! added sanity check for news server responses
! allow SMTP/POP3 servers to process lines >512 characters
! BinkP CRC, MD5 and CRAM-MD5 modes can now be disabled or enabled on a per
  node basis for outgoing sessions
- prevent resend of mail for nodes whose accept RRQ status has changed since
  the files were queued
- corrects a problem with outbound netgate processing
- config fixups
- MIME multipart messages which didn't include a boundary could cause a crash
- MIME "message/partial" messages with insufficient parameters could cause a 
  crash
- if there were more NNTP news servers than inbound news threads, some
  servers weren't correctly checked for new news
- locked queue entries when tossing outbound FTP could cause a crash
- fix recursive FREQs off the root of the drive
- signature files longer than the original end of message were being cut off
  at the point where the original message ended
- Rex wasn't accepting confirmation of files with escaped characters in BinkP
  sessions
- file bundling status was backwards in Rexfix notify messages
- gateway mailing list digests weren't being posted if no listserver was
  defined
- fingering a user whose mailbox didn't exist would cause a crash
- Rex was attempting to re-download manifests and receipts from FTP sites
- made Rex a bit more resilient to munged TransX and Allfix key lines

Version 2.26
------------
December 18, 2000

+ added a signature file, available for all gates or overridable for
  specific gates
+ all but the ident server can now be multihomed
! watermark values for newsgroups can now be locked so the last n messages
  can be downloaded in each session
! netgate addresses now more accurately reflect the source of the message
  for conference messages with MSGID kludges
! Alt-S/Alt-F events will now auto-extend addresses to the main zone/net
  where necessary
! added stack tracing to exception processing under OS/2 and Windows
- config fixups
- gated mailing lists receiving mail through a Unix style mail spool were
  still including the spool's From header in posted messages
- finding recipient information through substring searches caused a crash
  occasionally when it couldn't be found in the first run
- Rex would decide all queue entries were locked if a system .DAT file didn't
  exist for PX/Windows
- crash mail to inactive nodes still generated attempts to reach the node if
  Rex was told to send crash mail immediately
- fix a sending loop in BinkP in multi-batch sessions where a file is skipped
- fix problem saving more than one filter for an email address or gateway
- session passwords for BinkP sessions were getting munged before being
  sent in the DOS 16-bit version
- in some cases when an outbound toss failed, Rex could stay logged into
  WinServer when it shouldn't have
- make sure to chmod 0600 Unix mail spool files after processing
- Rex wasn't checking return values on stat when reading a directory: could
  lead to invalid values on broken links under Linux
- PORT connections to the FTP server from the local machine wouldn't work
  under Linux
- extra whitespace in MIME headers could confuse Rex
- offer a more sensible default file directory when processing outbound gated
  packets
- on rare occasions, the .PKTs generated by inbound gating were written
  without .PKT headers
- prevent Rex from handling signals from its child processes with its own
  signal handlers under Linux
- separate Unix spool file messages on From instead of From/from
- under Linux, the FTP server couldn't log in non-system users when not run
  as root
- if the event processing thread was starved of processor time, an external
  event could cause a crash before executing

Version 2.25
------------
October 23, 2000

+ added an MD5 mode for BinkP to check for dupe files before transmission
  begins
+ added support for external FREQ processors, through both command-line
  options and SRIF files
+ email FREQs can now be crashed back to the person who requested them
+ Rex now can be told to search all subdirectories of a given directory for
  FREQed files
+ Rex now supports "update" FREQs
! allow @s in POP3/SMTP usernames
! certain kludges are now treated as possible email headers to support
  programs that put internet headers in kludges instead of plain text
! disallow overriding the To: header on outbound gated mailing lists
! NNTP sessions now apply filters by fetching the messages headers first,
  then the body if necessary
- -send/-fetch weren't including newsgroups when no other commandline options
  were given
- plug a memory leak in the FTP server when someone is dropped for too many
  failed login attempts
- config fixups
- inbound netgates weren't working properly on netmail addresses which had a 
  0 in any part of the address
- wildcard matches in netgates weren't working properly with wildcards which
  specified a point in the address for addresses which didn't have a point
  value
- Rex wasn't properly processing BinkP M_GOT messages for files it was 
  currently sending
- Rex could enter a sending loop in a BinkP session where one of the files
  to send was unavailable, a multi-batch session was initiated and the
  remote had no dupe detection
- FREQs through dedicated FREQ email addresses wouldn't get processed if the
  subject didn't contain "freq"
- certain invalid Date: headers in email messages could cause a crash when
  the messages were gated to the BBS
- fixes to Rexcfg for running Rex as a service under NT/2000
- the error message for gated email with no valid recipient was causing a
  crash
- converting charset to ^CHRS on inbound messages would cause a crash for
  iso-8859 character sets greater than 5 when character set translation
  was turned off
- stopped Rex from removing empty polls from Bink outbounds on rescan
- really fixed the hang with failed DUN and FTP sites
- improved recovery for when recipient information in multiuser mailboxes
  is misconfigured
- fix a crash on resend of the last file in a BinkP session if Rex is the
  initiator of the session
- in rare cases, Rex could corrupt FD's static queue if the queue were
  repacked between Rex finishing the rescan and starting a new session
- per day FREQ limits on anonymous sessions weren't being applied properly
- gated mail sent through a UUCP account didn't have a time in the From line,
  which offended some UUCP mailers

Version 2.24
------------
September 17, 2000

+ added [x]s[<news server ID>] for fetching/sending
+ FTP server welcome messages can now include various macros which Rex will
  expand inline (e.g. user's username or IP address, time, date, etc.)
+ BinkP 1.1 support
+ the FTP server can now optionally prevent server to server data connections
+ you can now optionally have Rex auto-delete malformed gated messages
+ Rex now uses sysop name / session password information from V7 and V7+
  compiled nodelists
+ you can now specify multiple hosts/ports for any machine Rex might try to
  connect to (FTP, POP3, SMTP, NNTP, BinkP) using a comma separated list of
  hosts[:ports]
+ added SMTP authentication for both client and server in Rex
+ daemon logging can now be set to use binary or text EOL sequences
+ the FTP server can now accept/deny connections based on IP address
+ certain FTP server security features can now be disabled if required
! added error messages for when Rex is unable to perform a queue modification
! nodes.rex and Rex's log file are now opened in shared read mode
! in route.rex, zones/nets are now extended to following entries if not
  specified
! Rex now alters incorrect or malformed dates in echomail messages so they
  aren't rejected by news servers
! messages with no subject are given the subject "-----" so they aren't
  rejected by news servers
! improved Rex's auto-renegotiation of PORT/PASV
! Rex now accounts for echomail programs which incorrectly terminate lines
  with CR/LF
! reverse DNS lookups can now be performed/logged on incoming connections
  for all daemons
! prevent starvation of news fetches on long sequences of empty groups
- queue entries linked to non-existent nodes crashed Rex and Rexcfg
- config fixups
- Rex could crash if more than 10 outbound threads were running at once and
  a new outbound FTP thread was started
- fix a crash if a known FTP user issued the STAT command and they'd ever
  uploaded a file to the server
- FTP thread viewers weren't reacting while data connections were being
  established
- corrected dupe checking on news posts from messages without MSGIDs
- a failed DUN connect would result in a hang if fetching from an FTP site
- removed a stray character that could occasionally insert itself after the
  zone in outbound netgate addresses
- if kill empty netmail was turned on, Rex was killing empty outbound FREQ
  messages
- news posts with lines beginning with . weren't being properly translated
- corrects a possible crash on resend of a file in a BinkP session
- Rex now accounts for cross-posted echomail messages when gating multiple
  echomail conferences to newsgroups
- Rex was aborting news fetches if a requested group didn't exist
- D'Bridge queueing fixups
- if there was exactly one new message in a newsgroup, Rex would ignore it
- gateway filters applied to newsgroups weren't working
- wildcard match filters weren't working properly
- messages moved in and out of gates #256 and higher were being moved through
  the wrong gates
- Rex's email address extraction routines were being a bit too restrictive
  on what characters were valid in email addresses
- fix moves under Linux when rename failed
- associated gate settings for newsgroups could get rewired, causing crashes
- GoldEd nodelist processing fixups
- mailing list gateways occasionally weren't extracting email addresses from
  inbound messages correctly
- if the last file of a BinkP transfer was aborted at the remote, it wasn't
  resent until a rescan was done locally
- a file resent to Rex during a BinkP CRC mode had its CRC interpreted
  incorrectly
- a BinkP resend request for the last file in a session which occurred after
  the contents of the entire file had been sent would crash Rex

Version 2.23
------------
June 14, 2000

+ added event?.now semaphore to run the event with tag ?
! made some changes to MX record lookup to improve performance with DNS
  servers which respond, but respond poorly to stream socket connects
! Rex now touches rexup.0 once per minute while running in daemon mode: if
  the file is more than two minutes old, Rex has probably crashed
! Rex now creates sleeping.rex in its semaphore directory while sleeping
! To: headers in gated messages can now contain multiple recipients
! events and mailing list digets can be set by days of the month now as well
  as days of the week
! changed Binkley outbound processing so only *.[chidno]ut and *.[chidnf]lo
  files are processed instead of *.?ut/*.?lo
! node in session semaphores which are more than 12 hours old will now be
  automatically removed
! greatly increases the speed of processing huge outbounds
- config fixups
- Rex wasn't closing/destroying mutex semaphores under OS/2: would eventually
  cause problems for systems with large numbers of newsgroups
- correct some redirection problems with spawned programs under Linux
- Rex was crashing when processing D'Bridge poll requests
- Rex was ignoring the file attach decoding instructions on newsgroups
- Rex could crash while mirroring an FTP directory if the directory listing 
  format couldn't be determined
- fixups to SMTP daemon logging for multi-line responses
- consecutive fetch+send BinkP events where no mail was transferred on the
  first event would result in no connection being made on following events
  until mail was available to send
- in some cases, Rex was deleting incomplete BinkP downloads instead of
  keeping them for completion later on
- fixes possible crash/memory corruption when reading news messages with
  headers >512 characters long
- Rex wasn't creating file attach messages for FD/APX file attach comments
- redirected BinkP connects done through the node manager and Rex in daemon
  mode would only work correctly the first time
- an MB mode BinkP connect where the last file sent was acknowledged fast
  enough could result in a timeout
- fixes a crash when processing huge (>10,000 files) outbounds
- Rex could crash if the config program was started while a BinkD session
  was going on and the BinkD session finished before the config program was
  terminated

Version 2.22
------------
May 17, 2000

+ added "SMTP must POP first" field for POP3/SMTP email accounts where the
  ISP requires that users POP their mail before being allowed to use the
  SMTP server
+ added % and ! paths for subdomains in Rex's gates
! Rex now runs BETWEEN.BAT when it receives files from inbound BinkP or FTP
  connections
! Rex now autodetects the format of TMail fileboxes and can process both
  short and long fileboxes in the same directory
! newsgroup watermarks can now be set to -n to have Rex fetch the last n
  messages in a group the first time it polls
- config fixups
- email FREQs with no FREQs in them processed on a fetch only wouldn't get
  help files sent out until a fetch/send
- outbound gateway filters weren't working on From: / To: / Subject: headers
- non To: or From: message headers weren't being properly RFC2047 encoded if
  they had <'s in them
- FTP links with Accept resend requests and Auto-resend unacked files turned 
  on which had both regular and resent mail queued up would crash Rex
- posting news in non-daemon mode could occasionally cause a crash on 
  shutdown
- messages with a TZUTC kludge posted in a timezone east of GMT had Date
  headers which were rejected by some news servers
- fixes a somewhat misleading error message about the archiver failing when 
  bundling outbound mail to an email node and the connection to the SMTP 
  server fails
- posts to non-moderated newsgroups didn't have the @/anti-spam part of their
  source address set
- corrects an incorrectly set flag in Eudora outbounds for more recent 
  versions of Eudora
- a screwed up UU/XXencoded file in a gated message where file attaches were
  stripped would result in a crash
- Rex could crash/hang on a re-transfer of a file during a BinkP session
- fixes some misbehaviour if no more space is available in the temp directory
- Rex was still fetching news for groups set to only go from Fido to the net
- Rexcfg wasn't saving gateway overrides if the only things changed were 
  header actions
- the config program wasn't initialising inbound/outbound headers conversion
  correctly, leading to crashes when gating if gating was first setup in 2.21 
- the gateway was processing messages marked hold when Rex was told not to
  send mail on hold

Version 2.21
------------
April 21, 2000

+ added logfile trimming for the FTP, SMTP and POP3 daemons
+ added listserv delivery loop detection
! changed the default .PKT type for echomail based gates to type 2+
- config fixups
- Rex wasn't matching clauses/filters correctly on rules involving <other>
  fields
- for FTP server VFSs with one entry mapped to / and another entry mapped to 
  a subdirectory of / where the user was given write access to /, uploads to 
  / could end up in Rex's install directory
- corrects a crash if Rex still can't determine the recipient of a message 
  once it's been gated
- Rex wasn't fetching news by default when asked to -fetch or -send
- the FTP server wasn't working when clients behind certain firewalls were
  accessing it
- Rex wasn't building .PKTs with more than one message in them correctly
- Rex could occasionally overterminate .PKTs that were marked "on hold"
- Rex wasn't properly threading news fetching when multiple news servers were
  used
- Rex wasn't properly loading email addresses or gates with more than one
  filter
- fixes crash when writing technical manual from rexcfgl under Linux
- Rex wasn't adding \r to the end of DOMAIN kludges when it generated them
- fetching news from DOS would result in an infinite loop
- in some conditions, Rex wasn't reading outbound .PKTs correctly
- aborted BinkP sends left a file handle open
- Rex wasn't logging out of WCServer when handling inbound BinkP sessions 
  with Platinum Xpress
- if Rex for Linux received two identical files in the same session, and
  both dupe detection and file case remapping were enabled, and the inbound
  was on a case sensitive file system, both the original and duplicate file
  would get removed


Version 2.20
------------
April 8, 2000

+ gating of news through NNTP, UUCP, Soup/Yarn or *.BAG is now available:
  includes MSGID/REPLY Message-ID/References/In-Reply-To linking/conversion,
  anti-spam From: headers, newsgroup/email gate association
+ added inbound and outbound filters for the gateway
+ the gateway settings can now be overridden on a per gate basis
+ filters/matching rules can now work on any header field
+ added negation and existence as possible requirements for filters/matching
  rules
+ echomail gates can now have the origin line set
+ gates can have additional matching rules which override or supplement the
  standard gating rules
+ added the KOI8-R codepage to the codepage data file
+ mailing list users can now request lists be sent as digests of the posts
  over a period of time (when the list is configured to allow this)
! the technical manual is no longer directly included in the distribution:
  run rexcfg -docs to produce it
! netgate entries can now include more than one wildcard of addresses to
  operate on
! switched the FTP daemon to defaulting to user "ftp" instead of user "guest"
  under Linux when no matching user could be found
! the SMTP server is no longer allowed to be an open relay
! Rex now cleans up Binkley .?lo files immediately after sending instead of 
  on the next rescan
! changed MIRROR/RMIRROR's behaviour slightly to allow it to try to mirror
  other sub-directories if one presents a non-fatal error
- config fixups
- shutting of TransX messages would cause a crash
- closes some open files left when FTP MIRROR, RMIRROR, DEL or RDEL commands
  fail in a particular way
- QUITting out of an FTP connection to the server while a transfer was still
  going would result in the transfer being severed immediately instead of
  waiting for it to complete, then logging out
- Rexcfg wasn't saving changes to the queued files in the queue editor
- .PKTs with mixed (send/don't send) messages weren't being properly
  processed by the gateway
- Rex wasn't respecting the crash flag on gated netmail
- Organisation as origin wasn't working properly
- Rex could misinterpret certain very long (> 4096 characters) headers when
  gating, causing them to be kludged/copied/stripped when they shouldn't be
- if Rex received two files with the same name under Linux with the inbound
  file case set to something other than "don't care", the second would
  overwrite the first
- Rex was screwing up message flags on inbound gated mail if messages were
  saved to .MSG files as opposed to .PKTs
- Rex could crash on startup of the FTP daemon under Linux in some cases
- corrects time/date/permission stamp on virtual directories under Linux
- the last message in a Unix style mail spool wasn't getting processed
- if an FTP server's virtual directory was hooked to a real subdirectory, the
  parent  directories of the subdirectory were displayed twice
- Rex wasn't logging thread IDs if max inbound/outbound threads were set to
  two
- Rex was eventually deciding it didn't want to load some mail/FTP users if
  the config files were locked and unlocked enough times
- fixups for UUCP spools in the SMTP daemon


Version 2.03
------------
March 18, 2000

+ added RFC2047 encoding/decoding of message headers
+ added codepage/charset translation for most single-byte character sets
+ added support for EMS in Rex itself under DOS 16-bit
! changed DOS overlay structure to reduce Rex's 16-bit memory requirements
- Rexcfg wasn't saving blank node passwords correctly, and could corrupt
  other password entries
- config fixups
- plugged a serious security hole in the FTP server under Win9x
- fixup for QFront queue processing
- correct crashes while rescanning KA9Q/UUCP spools with the SMTP daemon
- correct occasional crashes while reconstructing ^ASPLIT messages under OS/2
- various small fixups/optimisations to the BinkP code
- fix crash on login for Linux FTP server when users weren't using the native
  file system


Version 2.02
------------
March 3, 2000

+ added "Names must match" field to netmail<->email gates to allow multiple
  netmail<->email gates from the same Fido address
! BinkP protocol now generally requires less memory, unless the remote is
  using unusually large transfer windows
! improved Rex's processing on 4D systems kludged to 5D
! dropped the conventional memory requirements for the 16-bit version by
  16K or so
- config fixups
- gated messages with attached files could cause crashes
- the SMTP daemon was rejecting mail from <>
- corrects incorrectly generated routing commands from the update to 2.00
- fetching mail through an email address without a username could cause a 
  crash
- Rex wasn't adding SEEN-BY or PATH lines to its echomail, confusing some
  mail tossers
- if there were multiple addresses in the To: header of a message, Rex was
  only examining the first one
- Rex wasn't adding carriage returns to quoted-printable encoded messages
  correctly
- Rex was occasionally not seeing all the messages in .PKTs addressed to its
  gateways
- given a node with accept resend requests and auto-resend unacked files, if  
  the first file for that node was sent but a subsequent file couldn't be, 
  and the sent file was never acknowledged, Rex would crash on the resend
- corrected some stack faults with Rex and older versions of the OS/2 TCP/IP 
  stack
- colour fixups for progress bars
- Rex wasn't decoding Base64 encoded MIME type text/plain messages
- corrected ^CHRS <-> charset conversions
- Rex wasn't clearing up node in session semaphores if it was abruptly
  terminated
- Rex wasn't setting the inbound file case under Linux
- changing registration strings under Windows would hang the config program
- Rex was leaving files open if it encountered badly malformed .MSG files
- the SMTP server was using the wrong recipient information in UUCP and KA9Q
  queues


Version 2.01
------------
February 17, 2000

- config fixups
- shutting down Rex for Windows while an FTP user was online would cause an
  invalid memory access
- if Rex found an in session semaphore for an outbound FTP node, it would
  crash after shutting down the thread
- using the arrow keys in the queue manager when there was nothing in the
  queue would cause a crash
- Rex wasn't sending gated mail if no command line options were given
- domain store and forward mail users with no subdomain given were matching
  all destination email addresses instead of just those for the host
  domains
- Rex would delete all mail without processing it in some UUCP setups
- updated Windows dearchiver commands to allow * and *.* wildcards
- gateway mailing lists with more than 6 users could cause a crash
- rexcfg -stats reset could corrupt nodes.rex


Version 2.00
------------
February 13, 2000

+ Rex is now multithreaded (under multitasking OSes): up to 64 inbound or
  outbound tasks can be run simultaneously
+ Rex itself is more interactive
  - sessions can be terminated while running,
  - files can be skipped while they're being downloaded
  - in daemon mode, events can be run, mail can be fetched or sent
+ Rex's interface colours are configurable
+ queue structure radically changed: big speeds ups, less disk space
+ bullet proof crash protection and recovery
+ routing moved to route.rex file
  - allows for more fine tuned routing, near infinite routing statements, per
    event routing
  - each node now has a main address and up to 250 aliases
+ added an FTP server (multitasking OSes only)
  - multithreaded for smooth operation
  - virtual file systems allow flexible configuration of the site
  - per user file ratios, time online, simultaneous login control and 
    throughput control
  - auto-toss FTP users turn FTP sessions into mail sessions: no need for
    directory locking, files are tossed only when the user logs in or out
  - limited to two users in non-server versions
+ added an SMTP server (multitasking OSes only)
  - multithreaded for smooth operation
  - supports forwarding, aliasing, domain forwarding, mail robots, etc.
  - anti-spam measures including real-time black hole lists, reverse MX 
    lookup, spam filters and VRFY/EXPN control
  - extensive mailing list support (moderated lists, welcome messages,
    headers, footers, remote administration, public/private lists, etc.)
  - multiple spool formats: Rex native, KA9Q, UUCP and Unix style
  - limited to two users in non-server versions
+ added a POP3 server (multitasking OSes only)
  - multithreaded for smooth operation
  - APOP, TOP, CAPA, UIDL, extended response support
  - per user message expiry and mailbox quotas available
  - limited to two users in non-server versions
+ added a finger daemon (multitasking OSes only)
+ added a BinkP daemon (multitasking OSes only)
+ BinkP protocol expanded to include non-reliable (NR) mode, multiple batch
  (MB) mode, CRC mode, secure authentication (CRAM-MD5) and encrypted links 
  (with other copies of Internet Rex 2.0)
+ BinkP protocol rewritten for maximum asynchronous throughput
+ added an ident daemon (multitasking OSes only)
+ Rex now includes a full BBS <-> internet email gateway with support for 
  mailing lists, net gates and more
+ added external events
+ added history files (.HIS and text style)
+ added language files to Rex (translators welcome....)
+ added FTP script CHECK and CDLIST commands (checks for stale locks and
  lists a directory while CD'ing)
+ added password protection for the config program
+ better Linux support includes user configurable umask, uids and filename
  remapping
+ expanded wildcard support to include []
+ Rex can now be run as a service under Windows NT and 2000
+ added Rex encoding mail format: reduce size of encoded files up to 15%
+ added filters for email addresses: automatically bounce, delete or ignore
  messages matching your ruleset
+ nodelist support now processes Txy flags
+ two new email spools supported: Unix style RFC822 spool/SMTP server and
  Rex native direct interface
+ added native support for Beemail mailer and FD/APX
+ added support for GoldEd style compiled nodelists
+ 1000 node versions can send to nodes not in the node manager so long as
  the node has IP flags in a supported nodelist
+ added configurable socket and data timeouts for all OSes (not just DOS)
+ various and sundry other small features added
! -queue command line option no longer required
! Windows users can now paste into the config program using Shift+Ins
! improved MIME support in all areas of Rex
! Rex can be forced to exit in daemon mode using the rexexit.now semaphore
! rewrote buffer IO subsystem in Rex: better performance under OS/2 and
  Windows
! pause between redials in Windows is now configurable
! MIRROR/RMIRROR FTP commands now remove files from the HD if they aren't
  on the FTP site (UPDATE/RUPDATE don't)
! Rex can be run in daemon mode with no events defined
- Shotgun node-in-session semaphores were incorrect
- Rex wasn't properly restoring file dates on Allfix or SEAT messages
- FREQs from CD-ROMs weren't working
- Rex was adding LOCAL flags to FREQs it converted to .PKTs
- Rexdial could overflow its receive buffer if unusually long strings were
  received
- Rex for Linux was dropping screen characters if the screen descriptor
  filled up
- fixed disk sorting routines so they don't overreact if they're low on 
  memory
- various memory leaks plugged
- Rex was having problems reading directories under OS/2 on some IFSes
- Rex wasn't properly renaming arcmail bundles when used with D'Bridge
- Rex wasn't processing ~ marked files in Binkley outbounds correctly
- various and sundry other bugs squished

Version 1.19
------------
June 12, 1999

+ added support for compiled nodelists of FD, IM, BBBS, SGMail and V7+
  style nodelists for auto-configuring nodes
! / is now a valid directory to map to for Linux drive mapping
! new EMS/XMS/disk swapping routines for the DOS 16-bit version
! improved crash recovery for catastrophic crashes while sending mail
- corrected handling of resend requests in BinkP sessions
- fixed BinkP protocol to deal with spurious messages after M_EOB
- corrects Rex's way of dealing with an inconsistency in the FDSTQ format so
  that it works properly with Allfix
- Rex would crash if someone specified a Binkley style mailer but forgot
  to fill in the Binkley outbound directory
- CCed messages which were resent due to timeout could have the wrong email
  address used to send them if they were sent at a particular time
- TransX acks could occasionally crash Rex
- config program fixups
- plugs some memory leaks in daemon mode and fixes a few memory faults 
  elsewhere in the program

Version 1.18
------------
February 12, 1999

+ added EXCEPT processing for MIRROR/RMIRROR
+ made FTP scripts runnable as part of an event
! changed dialing timeout value in rexdial from 60 to 120 seconds to better
  deal with some V.90 modem setups
! Rex now chown's files tossed to directories under Linux to match the
  uid/gid of the directory they're tossed to
- summary information on queueing from Binkley outbound showed only the
  files queued from the last outbound directory, not all of them
- stack fixups
- MIRROR/RMIRROR on sites which provide a total line at the top of LISTings
  would always redownload the last file in the list
- changing the configs while Rex was running in daemon mode would result in
  Rex no longer trying to connect to FTP sites once the configs were reloaded
- receiving a receipt for a CCed SEAT message from an unknown node would
  crash Rex
- config fixups
- removed dependence on RAS DLL in Rexw and Rexcfgw
- files sent over email from a Rex for Windows system would be stamped with
  dates 60 years in the future
- files mirrored from an FTP site while FTP restarts were on weren't being
  re-timestamped

Version 1.17
------------
January 24, 1999

- for some mailers (PX, PCBoard, Qfront), Rex was queueing mail for all
  nodes regardless of the command line options passed in or the settings
  for the nodes themselves
- going through the "Save changes?" query an even number of times would
  corrupt the email address section of Rex
- multipart UUencoded messages were being truncated when sent: very small
  files sent in multiple parts could arrive without a proper end indciator

Version 1.16
------------
January 11, 1999

! small change made to BinkP protocol: Rex now ignores zero length BinkP
  packets
- mirror/update commands were decoding the date as one day earlier than
  the FTP site listed it
- MIRRORed files weren't being properly timestamped in the DOS 16-bit
  version
- Rex wasn't closing queue files properly for some mailers: could
  result in lost mail
- Rex in daemon mode in Windows would wait for input instead of proceeding
- config fixups
- fixups to commandline argument help
- when running in daemon mode, a dropped connection to a mail server would
  result in all future connections to mail servers failing
- fixes problem with some MIME semi-compliant mail servers
- packet/message structures weren't packed properly under Linux
- fixes odd crash when attempting to repair nodes
- additional corrections to Unix/DOS time conversion
- sockets opened to connect to non-responsive sites weren't being closed
  under OS/2, Windows and Linux
- fixups to MIRROR logic to get it working better with some LIST formats
- tuned the *GET* commands so NLST isn't done when GETting a single file
- the value for default FREQ encoding shown in the config program was
  opposite to what it was set to
- TransX and Allfix netmail saved to .PKTs would be deleted if no other
  types of netmail were generated in the same run

Version 1.15
------------
December 16, 1998

+ added many FTP commands, namely:
    MIRROR, RMIRROR, UPDATE, RUPDATE, RETURN, RLDEL, RLPUT, RLPUTDEL, GOTO,
    USER, PASS, LOGIN, LOGOUT, FOR <var> IN ... END, LFOR <var> IN ... END,
    GETDEL, LGETDEL, RGET, RGETDEL, RLGET, RLGETDEL
+ added labels for GOTO command in FTP
+ FTP scripts can return testable errorlevels via the RETURN command
+ FTP SCRIPT commands now accept parameters which can be used in subscripts
  via %1, %2, %3, etc.
+ added %mday, %wday, %hour and %min FTP macros for conditional processing of
  times
+ added %status macro for conditional processing of command return values
+ added -runscript parameter to run FTP scripts from Rex's command line
+ added string comparison equality conditionals to FTP IF command for use
  with parameters and <var> in FOR/LFOR commands
+ added flags to determine whether or not nodes will receive RexFix help or
  notify messages
+ added / to \ translation for DOS, OS/2 and Windows versions in all files
  and paths
! FTP SCRIPT commands can now nest (nesting depth is limited by available
   stack memory
- corrected Unix to DOS time conversion routine
- running Rex would fail if there were no nodes defined
- the .PKT created for inbound gated email wasn't being properly terminated
- fix some problems Rex has when .RQ files are removed by external sources
- Rexcfg would clear packing info which hadn't been saved yet if it was
  re-edited
- initialisation routines for Toss From Mail would set the Download via
  field to the same as the one in Toss To Mail, even if the address in
  question was outbound only
- missed an "Internet Rex"/"Irex" for gated netmail/email
- Rex would die while decoding a file if it couldn't guess the encoding
  type
- fixed processing of MIME multipart/digest messages so each part is treated
  as message/rfc822 instead of text/plain
- more encryption fixups for FTP/dir transfers

Version 1.12
------------
November 18, 1998

+ added FTP RUN command
+ added ERRORLEVEL conditional to FTP IF command (for use with RUN)
+ added username/password masking for logging
! changed structure of ELSE commands to allow
  IF-ELSE IF-ELSE IF...-ELSE-ENDIF style commands
! changed redials setting to allow up to 250 or infinite redials
! expanded unsupported ALLO command detection to include any response in
  the 500 category
! "UUCP" style gated email can now be written to "Internet Rex" or "Irex"
! the To: header on the first line of UUCP style gated email no longer
  requires a space between the To: and the email address
- 32-bit packet driver code was allocating 1/16th the correct amount of
  DOS memory, causing semi-random crashes on shutdown
- Rex wasn't deleting FREQ messages it was told to from inbound .PKTs
- account for bug in WinServer's DLL unloading routine which could cause
  random crashes while sending
- fixed -daemon switch showing command line help in beginner mode
- config program wouldn't let you set the PX system directory if you started
  a new config
- fixed bug from Watcom's source for the DOS4GW stub program
- changed the DOS socket code so it doesn't wait for closes on unaccepted
  listen sockets
- fixed bug in POP3 cacheing routines which would very occasionally result
  in hangs while receiving a message
- fixed not closing the POP3 socket when receiving mail was aborted in some
  cases
- inbound messages whose addresses defaulted to the main address wouldn't
  have the TOPT/FMPT information set correctly
- dummy queueheader for auto-send nodes wasn't being cleared before use
- disconnected or misconnected mail servers would queue the first file in
  a batch, but incorrectly mark the remaining ones as sent
- fixed Rex not deleting the busy semaphore when an incorrect argument was
  given

Version 1.11
------------
November 6, 1998

+ Rex for DOS now available in a 32-bit version
+ added inbound file case option for Linux users to set all inbound files
  to a particular case
- DOS 16-bit version didn't initialise packet driver variables correctly
- FTP SCRIPT command would run only the first line of the script file if it 
  was the last line in the script
- OS/2 screen restored properly after executing dial.cmd
- fixed unclosed file in partial processing (could crash Rex in daemon mode)
- fixed encryption on first file in toss from directory/FTP
- on occasion, Rex would not check for mail from individually specified
  nodes who received mail via email
- passwords weren't being loaded correctly in DOS 16-bit version of Rex
- Linux screen init would crash rexcfgl if running in a terminal which was
  less than 80x25
- Binkley processing wouldn't add the right default zone for non-standard
  outbounds with no zone extension

Version 1.10
------------
November 1, 1998

+ added daemon mode for Rex
+ added RexFix remote management
+ added inbound TIC path for Platinum Xpress
+ added PID kludge for inbound gated email messages
+ added FTP SCRIPT command to read a script from a separate file
+ added wildcard matching for addresses given on the command line
+ improved DUN support for OS/2 and Linux
! changed maximum length of FTP scripts to 250 lines
! changed From line for UUCP messages to reflect entire email address
! changed FTP scripting so that ALLO is turned off for a site after the
  first unsupported command response
! changed FTP scripting so that servers which don't understand STOU with
  a filename get STOR instead
! changed zone mapping limit from 25 to 100
! optimised some of Rex's queuing routines so it isn't quite as disk
  intensive
! changed non-graphical mode to allow for echoing the log to the screen
- fixed WinServer code for PX
- various config fixups
- adjustment made to Windows key reading routines to allow for Key Events
  with funky AsciiChar codes (resulted in arrow keys not working on some
  systems)
- Rex wasn't deleting in transit netmail if the Kill/Sent flag wasn't on
- memory leak / memory management fixups
- BinkP sessions weren't working correctly under Linux
- outbound BinkP mail was being deleted if the BinkP site wasn't responding
- zone mappings weren't always renumbered correctly after deleting an AKA
- directory verification could cause a seg fault under Linux with directory
  mapping on
- the default Binkley outbound wasn't being scanned under Linux
- command line help under Linux wasn't being displayed properly
- spawned programs under Linux were still calling Rex's atexit functions

Version 1.01
------------
September 26, 1998

! stopped logging TransX message xfers when running in native mode
- fixed crash on init bug in rexdial.exe for DOS
- inbounds weren't being loaded for deciding which email address to check
  for mail for in the DOS version
- attached files weren't being logged for PCBoard, QFront and PX queues
- fixed using wrong decryption function on SEAT L4 messages
- passwords were being double processed when dealing with multipart messages

Version 1.00
------------
September 21, 1998

+ added support for TransX compatible encoding/decoding in Rex
+ added support for reconstructing gateway messages split at the gateway
  using the ^ASPLIT kludge
+ command line allows selecting nodes by the email address they're sent/rcvd
  through
+ FREQ permissions and limits can be controlled on a per connection or
  wildcard basis using the FREQ access file
+ nodes can now be set to inactive, receive files only, send files only
  or active
! various config program fixups
- fix Rex's detection of the end of multipart multipart MIME messages
- fix deletion of records in QFront processing
- fix double mungeing of filenames
- fix marking files not sent because email addresses were invalid being
  marked sent
- duplicate files from auto-extract nodes would cause a crash
- fixed initialisation of stats info for new nodes
- BinkP nodes would cause a crash while printing the nodelist
- changed STATS.TXT and DATES.TXT EOL character to match the log file's
- bundle listfile names were being incorrectly generated under DOS
- help function fixup for short help screens with per item links

Version 0.99C
-------------
September 1, 1998

! change placement of RSET commands in SMTP sessions so that mail sending
  can resume when possible
! non-DOS archive names now result in individual files being sent in Rex
  for DOS
- Rex wasn't dealing with Soup/Yarn binary formats correctly
- anonymous toss from mail info wasn't being properly initialised
- auto-setup code for configuring toss from mail info wasn't initialising
  the matched flag to zero
- BinkP downloads weren't being deleted if the session was aborted midway
  through a file download
- PMMail FOLDER.BAG was indicating that all outbound messages had files
  attached to them

Version 0.99B
-------------
August 28, 1998

+ added "binary mode/text mode" switch for changing the end of line style
  used during logging
+ added ability to save/load custom colour configs
+ added -dates option to rexcfg to print out dates files were sent/queued/
  received for each node
+ added gateway support for DOS version
! improved file mungeing routines so they no longer use non-printable
  characters in filenames
! moved the configuration of log trimming to the more sensible logging
  options screen from the Rex's behaviour screen
- fixed crash on startup bug in Win98
- same bug caused unusal problems throughout Rex - fixed
- fixed double queueing of .PKTs in packet processing
- decryption of passwords occasionally incorrect
- -ip option wasn't working correctly
- switching SMTP servers during outbound would cause a crash
- fixed problem of update program adding a character at the start of
  encryption passwords
- messages to a FREQ "only" mail address with no subject line would cause
  a crash

Version 0.99A
-------------
August 18, 1998

+ logging of who unidentified messages are from
- outbound info for FTP sites wasn't being loaded in the scan for 'always
  connect' sites under DOS
- .MSGs sent through Allfix would crash Rex
- share problems in DOS config program fixed
- automatic script code wasn't allocating enough memory for the script
- QFront processing fixups

Version 0.99
------------
August 17, 1998

+ CC file attach emails
+ BinkP protocol support
+ Linux version available
+ user definable colour schemes for config program
+ user interface levels
+ support for QFront mailer
+ inbound messages can be saved to .MSG, or one of 4 .PKTs
+ outbound .PKT types can be specified on a per node bases
+ autodetected timeslice support for DOS 5.0+, OS/2 DOS windows and Win95
  DOS windows
+ email FREQs can have the default encoding and chunk size set
+ FTP put and get commands can now take wildcards and exceptions
+ New FTP commands: IF-ELSE-ENDIF, LCD, LDEL, LGET, LPUT, LPUTDEL, LWAIT,
  QUIT, QUOTE and WAIT.  CHECK and FOUND commands removed.
+ duplicate inbound file detection can be extended to any node files are
  received from
+ outbound file bundles can have the size set
+ .MSGs can be read as Opus 1.02 or FTS-0001
+ vastly improved socket code: messages downloaded up to 20x faster
+ MTU size settable for DOS version
+ SEAT 001.004 level 4 compliancy
+ CPS indicator on progress bars
+ "Save changes" option added at config shutdown
! FREQ messages with FREQ commands in them get the helpfile sent back to
  them
! an invalid email address no longer results in Rex dropping the whole 
  SMTP session, just that one file
! swapping to EMS/disk can be disabled for DOS version
- various config program fixups
- filename mungeing commands were mungeing but the result wasn't being used
- PCBoard bundle truncation fixed
- date stats wouldn't print correctly under DOS
- address buffer wasn't zeroed before reading address (PCBoard fixup)
- PCBoard processing wasn't skipping deleted entries
- some empty Allfix messages were still being posted to netmail even if
  the 'post empty messages' option was off
- tokenizing of multiple files in a .MSG would screw up under Win95
- Sent/Rcvd .MSGs would occasionally have files added to attachment queues
  when they shouldn't have been
- INTL kludge lines were being read as 4D and overwriting any TOPT kludges
  before them
- MIME headers of multipart messages were not compliant
- FREQ scanning no longer scans all drives/directories when wildcard 
  FREQing is urned off and a match has already been found
- removed extra carriage return when sending UUCP gateway messages through
  a netmail/email gateway
- stats weren't being updated for auto-extract inbound nodes

Version 0.98C
-------------
June 27, 1998

+ number of lines for FTP scripts increased to 125 from 20
+ TransX gating updated to reflect changes in TX/TXMailer 2.6
- if there were no nodes defined, anonymous mail wasn't sent
- PCBoard queue processing now truncates files when dealing with arcmail
  bundles
- Soup/Yarn processing would delete news entries in the AREAS file
- fixes deletion of inbound arcmail bundles for PX if the inbound mail and
  inbound files directories were the same

Version 0.98B
-------------
June 6, 1998

+ improved logging for incoming mail messages to identify source and type
  of message
- PCBoard queue entry deletion procedure changed
- failed FTP uploads would delete files from the queue
- .PKT generation routines corrected for some incorrectly generated .MSG
  files
- Fido gated email updated
- occasional crashes in Win95 version at the end of processing fixed

Version 0.98A
-------------
April 28, 1998

! PX processing now has inbound file/inbound mail directories instead of
  inbound and secure inbound
- config options for various mail types weren't point to the right spot
- corrected arcmail bundle name generation routine
- update from 0.96 to 0.98 would corrupt the amount of time Rex had been
  used
- fixed problem of unclosed file handles when processing lots of FREQs
  from anonymous nodes

Version 0.98
------------
April 13, 1998

+ support for FD 2.25+, Platinum Xpress, PCBoard 15.22+, *.PKT mailers
+ support for Soup/Yarn, PMMail, Postroad mailer, MR/2 Ice, Eudora and
  Nettamer
+ DOS TCP/IP can be configured through BOOTP when the driver supports it
+ DOS memory footprint reduced using overlays
+ Rex swaps to EMS/disk before running shelled DOS programs
+ POP3 login using APOP now supported
+ SEAT support for level 4 of SEAT 001.003
+ FTP uploads can have the case of the filenames set
! Fido2Int "Files sent" messages can be auto-stripped by configuring toss
  from mail nodes to delete all or empty incoming messages
- packet level passwords without session level passwords would cause crashes
  when sending files
- requeued files weren't being correctly processed
- blank lines are no longer stripped on incoming email
- seven letter UUCP hostnames weren't being correctly munged
- several config program fixups
- DOS crashes wouldn't shut down the packet driver correctly

Version 0.97
------------
January 19, 1997

+ multiple email addresses supported
+ multiple inbound mail queues supported
+ dedicated FREQ addresses available
+ 5D outbounds supported for mailers that understand them
+ automatic renegotiation to PASV mode if active FTP connections fail
+ packet level passwords now settable for packed outbound netmail
+ long filename mungeing added for OSs where it's a problem
+ multipart UUencoded files using the 'section # of xxx of <filename>' are
  now decoded (eg. for use with GIGO connects)
+ user settable socket timeouts for all OSs
+ line wraps settable for netmail to email gating
+ FD style log
+ UUCICO DOS filenames with no bitmask now supported
+ monochrome mode added for config program
+ paths can now contain environment variables (replaced at runtime), enclose
  them in <>s (eg. n:\fd\fd<TASK>.log)
+ new queue structure for faster processing
- various FTP problems under DOS fixed
- AdeptX queueing fixed
- OS/2 automatic scripts fixed up
- revised keyboard reading procedure for Win95 to get around problems with
  various keyboards
- receipt processing for FTP/toss to directory was broken
- only the first file sent in a session for a particular node was being
  encrypted properly
- unusually large header fields in email no longer crash Rex
- FTP lock files are now 1 byte instead of 0
- FTP directory listings no longer rely on the server correctly matching *
- various UUCP fixups
- TCP/IP DLLs for OS/2 are only loaded when needed (for those who haven't
  installed the IAK)
- Fido/Internet gateway messages with header fields in ^A kludges are
  correctly processed

Version 0.96E
-------------
December 29, 1997

+ Email FREQ processing has been enhanced.  See FREQHELP.TXT for more 
  details.
- KA9Q spool processing has been corrected.
- UUCP spool processing has been corrected.
- Inserting a new node would cause the config program to crash.

Version 0.96
------------
December 23, 1997

+ DOS version released.
+ Printable docs added.
+ File bundling available for all transfer types (not just via email).
+ Headers for MIME/none and FIDS transport mail are now customizable.
  (see header.txt for details)
+ UNIX standard long filename outbounds for UUCP now supported.
+ Logging changed to be more verbose in debug mode, a little less verbose
  in standard mode.
+ Help keywords can be navigated using tab and shift-tab.
+ Incoming mail can be searched for using the X-Mailer field.
+ Native OS/2 dialer added for those wanting to automate PPP/SLIP connections.
! Inbound UUCP queue processing now uses the .X files to find associated .D
  files instead of assuming they have the same prefix.
! The Win95/NT auto-hangup feature has been changed to leave the connection
  open regardless of what other programs may be using it.
- Running Rex with only FTP nodes left the TCP/IP code untinitialized.
- File deletion routines will now nuke files with no attributes set in Win95.
- Multiline responses from SMTP servers were confusing Rex.
- Queueing 0 byte files would hang Rex.
- The send hold mail flag was being ignored for *.MSG netmail.
- Empty "netmail to email" gated messages weren't being deleted.
- Deleting entries in the compression programs menu caused a crash in the
  config program.

Version 0.95
------------
December 1, 1997

! First public release
